<?php

namespace Drupal\migrate_gathercontent\Controller;

use Drupal\Core\Url;
use Drupal\migrate_tools\Controller\MigrationListBuilder;
use Drupal\Core\Entity\EntityInterface;

/**
 * Provides a listing of migration entities in a given group.
 *
 * @package Drupal\migrate_tools\Controller
 *
 * @ingroup migrate_tools
 */
class GatherContentMigrationListBuilder extends MigrationListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $migration_entity) {

    $row = parent::buildRow($migration_entity);

    // Add edit and delete operations if it's gathercontent.
    $source = $migration_entity->get('source');
    if ($source['plugin'] == 'gathercontent') {
      if ($migration_entity->get('source')) {

        $migration_group = $migration_entity->get('migration_group');
        $row['operations']['data']['#links'] += [
          'edit' => [
            'title' => $this->t('Edit'),
            'url' => Url::fromRoute('entity.migration.edit_form', [
              'migration' => $migration_entity->id(),
            ]),
          ],
          'delete' => [
            'title' => $this->t('Delete'),
            'url' => Url::fromRoute('entity.migration.delete_form', [
              'migration' => $migration_entity->id(),
              'migration_group' => $migration_group,
            ]),
          ],
        ];
      }
    }
    return $row;
  }

}
