<?php

namespace Drupal\migrate_gathercontent\Plugin;

use Drupal\migrate\Plugin\MigrationInterface;
use Drupal\Core\Entity\EntityInterface;

/**
 * Defines an interface for migrate fields.
 *
 * @see \Drupal\migrate_gathercontent\Plugin\MigratePluginManager
 * @see \Drupal\migrate_gathercontent\Annotation\GatherContentField
 * @see plugin_api
 *
 * @ingroup migration
 */
interface FieldPluginBaseInterface {

  /**
   * Apply any custom processing to the field bundle migrations.
   *
   * @param \Drupal\migrate\Plugin\MigrationInterface $migration
   *   The migration entity.
   * @param string $field_name
   *   The field name we're processing the value for.
   * @param string $source
   *   The source value.
   * @param \Drupal\Core\Entity\EntityInterface $entity
   *   The entity.
   */
  public function defineValueProcessPipeline(MigrationInterface $migration, $field_name, $source, EntityInterface $entity);

}
